Skip to content

Create FHIR r4 questionnaire

Request

Security
bearer or bearer
Path
siteIdstringrequired

Site identifier

Bodyapplication/jsonrequired
resourceTypeanyrequired

This is a Questionnaire resource

Value:"Questionnaire"
Example:"Questionnaire"
idstring(id)^[A-Za-z0-9\-\.]{1,64}$

The logical id of the resource, as used in the URL for the resource. Once assigned, this value never changes.

Example:"example-id"
metaobject(Meta)

The metadata about the resource. This is content that is maintained by the infrastructure. Changes to the content might not always be associated with version changes to the resource.

implicitRulesstring(uri)^\S*$

A reference to a set of rules that were followed when the resource was constructed, and which must be understood when processing the content. Often, this is a reference to an implementation guide that defines the special rules along with other profiles etc.

Example:"https://example.org/resource"
_implicitRulesobject(Element)

Extensions for implicitRules

languagestring(code)^[^\s]+(\s[^\s]+)*$

The base language in which the resource is written.

Example:"sample-code"
_languageobject(Element)

Extensions for language

textobject(Narrative)

A human-readable narrative that contains a summary of the resource and can be used to represent the content of the resource to a human. The narrative need not encode all the structured data, but is required to contain sufficient detail to make it "clinically safe" for a human to just read the narrative. Resource definitions may define what content should be represented in the narrative to ensure clinical safety.

Example:
{ "status": "generated", "div": "<div xmlns=\"http://www.w3.org/1999/xhtml\">\n <pre>\n 1.Comorbidity?\n 1.1 Cardial Comorbidity\n 1.1.1 Angina?\n 1.1.2 MI?\n 1.2 Vascular Comorbidity?\n ...\n Histopathology\n Abdominal\n pT category?\n ...\n </pre>\n </div>" }
containedArray of any(ResourceList)

These resources do not have an independent existence apart from the resource that contains them - they cannot be identified independently, and nor can they have their own independent transaction scope.

extensionArray of objects(Extension)

May be used to represent additional information that is not part of the basic definition of the resource. To make the use of extensions safe and manageable, there is a strict set of governance applied to the definition and use of extensions. Though any implementer can define an extension, there is a set of requirements that SHALL be met as part of the definition of the extension.

modifierExtensionArray of objects(Extension)

May be used to represent additional information that is not part of the basic definition of the resource and that modifies the understanding of the element that contains it and/or the understanding of the containing element's descendants. Usually modifier elements provide negation or qualification. To make the use of extensions safe and manageable, there is a strict set of governance applied to the definition and use of extensions. Though any implementer is allowed to define an extension, there is a set of requirements that SHALL be met as part of the definition of the extension. Applications processing a resource are required to check for modifier extensions.

Modifier extensions SHALL NOT change the meaning of any elements on Resource or DomainResource (including cannot change the meaning of modifierExtension itself).

urlstring(uri)^\S*$

An absolute URI that is used to identify this questionnaire when it is referenced in a specification, model, design or an instance; also called its canonical identifier. This SHOULD be globally unique and SHOULD be a literal address at which at which an authoritative instance of this questionnaire is (or will be) published. This URL can be the target of a canonical reference. It SHALL remain the same when the questionnaire is stored on different servers.

Example:"https://example.org/resource"
_urlobject(Element)

Extensions for url

identifierArray of objects(Identifier)

A formal identifier that is used to identify this questionnaire when it is represented in other formats, or referenced in a specification, model, design or an instance.

versionstring(string)^[ \r\n\t\S]+$

The identifier that is used to identify this version of the questionnaire when it is referenced in a specification, model, design or instance. This is an arbitrary value managed by the questionnaire author and is not expected to be globally unique. For example, it might be a timestamp (e.g. yyyymmdd) if a managed version is not available. There is also no expectation that versions can be placed in a lexicographical sequence.

Example:"example-string"
_versionobject(Element)

Extensions for version

namestring(string)^[ \r\n\t\S]+$

A natural language name identifying the questionnaire. This name should be usable as an identifier for the module by machine processing applications such as code generation.

Example:"example-string"
_nameobject(Element)

Extensions for name

titlestring(string)^[ \r\n\t\S]+$

A short, descriptive, user-friendly title for the questionnaire.

Example:"example-string"
_titleobject(Element)

Extensions for title

derivedFromArray of strings

The URL of a Questionnaire that this Questionnaire is based on.

Example:
[ "http://example.org/Profile" ]
statusany

The status of this questionnaire. Enables tracking the life-cycle of the content.

Enum:"draft""active""retired""unknown"
Example:"draft"
_statusobject(Element)

Extensions for status

experimentalboolean(boolean)^true|false$

A Boolean value to indicate that this questionnaire is authored for testing purposes (or education/evaluation/marketing) and is not intended to be used for genuine usage.

Example:true
_experimentalobject(Element)

Extensions for experimental

subjectTypeArray of strings

The types of subjects that can be the subject of responses created for the questionnaire.

Example:
[ "sample-code" ]
_subjectTypeArray of objects(Element)

Extensions for subjectType

datestring, (date-time)(dateTime)^([0-9]([0-9]([0-9][1-9]|[1-9]0)|[1-9]00)|[1-...

The date (and optionally time) when the questionnaire was published. The date must change when the business version changes and it must change if the status code changes. In addition, it should change when the substantive content of the questionnaire changes.

Example:"2024-01-01T00:00:00Z"
_dateobject(Element)

Extensions for date

publisherstring(string)^[ \r\n\t\S]+$

The name of the organization or individual that published the questionnaire.

Example:"example-string"
_publisherobject(Element)

Extensions for publisher

contactArray of objects(ContactDetail)

Contact details to assist a user in finding and communicating with the publisher.

descriptionstring(markdown)^[ \r\n\t\S]+$

A free text natural language description of the questionnaire from a consumer's perspective.

Example:"Sample markdown text"
_descriptionobject(Element)

Extensions for description

useContextArray of objects(UsageContext)

The content was developed with a focus and intent of supporting the contexts that are listed. These contexts may be general categories (gender, age, ...) or may be references to specific programs (insurance plans, studies, ...) and may be used to assist with indexing and searching for appropriate questionnaire instances.

jurisdictionArray of objects(CodeableConcept)

A legal or geographic region in which the questionnaire is intended to be used.

purposestring(markdown)^[ \r\n\t\S]+$

Explanation of why this questionnaire is needed and why it has been designed as it has.

Example:"Sample markdown text"
_purposeobject(Element)

Extensions for purpose

copyrightstring(markdown)^[ \r\n\t\S]+$

A copyright statement relating to the questionnaire and/or its contents. Copyright statements are generally legal restrictions on the use and publishing of the questionnaire.

Example:"Sample markdown text"
approvalDatestring, (date)(date)^([0-9]([0-9]([0-9][1-9]|[1-9]0)|[1-9]00)|[1-...

The date on which the resource content was approved by the publisher. Approval happens once when the content is officially approved for usage.

Example:"2024-01-01"
_approvalDateobject(Element)

Extensions for approvalDate

lastReviewDatestring, (date)(date)^([0-9]([0-9]([0-9][1-9]|[1-9]0)|[1-9]00)|[1-...

The date on which the resource content was last reviewed. Review happens periodically after approval but does not change the original approval date.

Example:"2024-01-01"
_lastReviewDateobject(Element)

Extensions for lastReviewDate

effectivePeriodobject(Period)

The period during which the questionnaire content was or is planned to be in active use.

codeArray of objects(Coding)

An identifier for this question or group of questions in a particular terminology such as LOINC.

itemArray of objects(Questionnaire_Item)

A particular question, question grouping or display text that is part of the questionnaire.

Example:
[ { "linkId": "1", "code": [ … ], "type": "group", "item": [ … ] }, { "linkId": "2", "code": [ … ], "type": "group", "item": [ … ] } ]
curl -i -X POST \
  'https://docs.axiomera.com/_mock/apis/fhir/openapi/site/{siteId}/fhir/questionnaire' \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>' \
  -H 'Content-Type: application/json' \
  -d '{
    "resourceType": "Questionnaire",
    "id": "3141",
    "text": {
      "status": "generated",
      "div": "<div xmlns=\"http://www.w3.org/1999/xhtml\">\n      <pre>\n            1.Comorbidity?\n              1.1 Cardial Comorbidity\n                1.1.1 Angina?\n                1.1.2 MI?\n              1.2 Vascular Comorbidity?\n              ...\n            Histopathology\n              Abdominal\n                pT category?\n              ...\n          </pre>\n    </div>"
    },
    "url": "http://hl7.org/fhir/Questionnaire/3141",
    "title": "Cancer Quality Forum Questionnaire 2012",
    "status": "draft",
    "subjectType": [
      "Patient"
    ],
    "date": "2012-01",
    "item": [
      {
        "linkId": "1",
        "code": [
          {
            "system": "http://example.org/system/code/sections",
            "code": "COMORBIDITY"
          }
        ],
        "type": "group",
        "item": [
          {
            "linkId": "1.1",
            "code": [
              {
                "system": "http://example.org/system/code/questions",
                "code": "COMORB"
              }
            ],
            "prefix": "1",
            "type": "choice",
            "answerValueSet": "http://hl7.org/fhir/ValueSet/yesnodontknow",
            "item": [
              {
                "linkId": "1.1.1",
                "code": [
                  {
                    "system": "http://example.org/system/code/sections",
                    "code": "CARDIAL"
                  }
                ],
                "type": "group",
                "enableWhen": [
                  {
                    "question": "1.1",
                    "operator": "=",
                    "answerCoding": {
                      "system": "http://terminology.hl7.org/CodeSystem/v2-0136",
                      "code": "Y"
                    }
                  }
                ],
                "item": [
                  {
                    "linkId": "1.1.1.1",
                    "code": [
                      {
                        "system": "http://example.org/system/code/questions",
                        "code": "COMORBCAR"
                      }
                    ],
                    "prefix": "1.1",
                    "type": "choice",
                    "answerValueSet": "http://hl7.org/fhir/ValueSet/yesnodontknow",
                    "item": [
                      {
                        "linkId": "1.1.1.1.1",
                        "code": [
                          {
                            "system": "http://example.org/system/code/questions",
                            "code": "COMCAR00",
                            "display": "Angina Pectoris"
                          },
                          {
                            "system": "http://snomed.info/sct",
                            "code": "194828000",
                            "display": "Angina (disorder)"
                          }
                        ],
                        "prefix": "1.1.1",
                        "type": "choice",
                        "answerValueSet": "http://hl7.org/fhir/ValueSet/yesnodontknow"
                      },
                      {
                        "linkId": "1.1.1.1.2",
                        "code": [
                          {
                            "system": "http://snomed.info/sct",
                            "code": "22298006",
                            "display": "Myocardial infarction (disorder)"
                          }
                        ],
                        "prefix": "1.1.2",
                        "type": "choice",
                        "answerValueSet": "http://hl7.org/fhir/ValueSet/yesnodontknow"
                      }
                    ]
                  },
                  {
                    "linkId": "1.1.1.2",
                    "code": [
                      {
                        "system": "http://example.org/system/code/questions",
                        "code": "COMORBVAS"
                      }
                    ],
                    "prefix": "1.2",
                    "type": "choice",
                    "answerValueSet": "http://hl7.org/fhir/ValueSet/yesnodontknow"
                  }
                ]
              }
            ]
          }
        ]
      },
      {
        "linkId": "2",
        "code": [
          {
            "system": "http://example.org/system/code/sections",
            "code": "HISTOPATHOLOGY"
          }
        ],
        "type": "group",
        "item": [
          {
            "linkId": "2.1",
            "code": [
              {
                "system": "http://example.org/system/code/sections",
                "code": "ABDOMINAL"
              }
            ],
            "type": "group",
            "item": [
              {
                "linkId": "2.1.2",
                "code": [
                  {
                    "system": "http://example.org/system/code/questions",
                    "code": "STADPT",
                    "display": "pT category"
                  }
                ],
                "type": "choice"
              }
            ]
          }
        ]
      }
    ]
  }'

Responses

Bodyapplication/json
resourceTypeanyrequired

This is a Questionnaire resource

Value:"Questionnaire"
Example:"Questionnaire"
idstring(id)^[A-Za-z0-9\-\.]{1,64}$

The logical id of the resource, as used in the URL for the resource. Once assigned, this value never changes.

Example:"example-id"
metaobject(Meta)

The metadata about the resource. This is content that is maintained by the infrastructure. Changes to the content might not always be associated with version changes to the resource.

implicitRulesstring(uri)^\S*$

A reference to a set of rules that were followed when the resource was constructed, and which must be understood when processing the content. Often, this is a reference to an implementation guide that defines the special rules along with other profiles etc.

Example:"https://example.org/resource"
_implicitRulesobject(Element)

Extensions for implicitRules

languagestring(code)^[^\s]+(\s[^\s]+)*$

The base language in which the resource is written.

Example:"sample-code"
_languageobject(Element)

Extensions for language

textobject(Narrative)

A human-readable narrative that contains a summary of the resource and can be used to represent the content of the resource to a human. The narrative need not encode all the structured data, but is required to contain sufficient detail to make it "clinically safe" for a human to just read the narrative. Resource definitions may define what content should be represented in the narrative to ensure clinical safety.

Example:
{ "status": "generated", "div": "<div xmlns=\"http://www.w3.org/1999/xhtml\">\n <pre>\n 1.Comorbidity?\n 1.1 Cardial Comorbidity\n 1.1.1 Angina?\n 1.1.2 MI?\n 1.2 Vascular Comorbidity?\n ...\n Histopathology\n Abdominal\n pT category?\n ...\n </pre>\n </div>" }
containedArray of any(ResourceList)

These resources do not have an independent existence apart from the resource that contains them - they cannot be identified independently, and nor can they have their own independent transaction scope.

extensionArray of objects(Extension)

May be used to represent additional information that is not part of the basic definition of the resource. To make the use of extensions safe and manageable, there is a strict set of governance applied to the definition and use of extensions. Though any implementer can define an extension, there is a set of requirements that SHALL be met as part of the definition of the extension.

modifierExtensionArray of objects(Extension)

May be used to represent additional information that is not part of the basic definition of the resource and that modifies the understanding of the element that contains it and/or the understanding of the containing element's descendants. Usually modifier elements provide negation or qualification. To make the use of extensions safe and manageable, there is a strict set of governance applied to the definition and use of extensions. Though any implementer is allowed to define an extension, there is a set of requirements that SHALL be met as part of the definition of the extension. Applications processing a resource are required to check for modifier extensions.

Modifier extensions SHALL NOT change the meaning of any elements on Resource or DomainResource (including cannot change the meaning of modifierExtension itself).

urlstring(uri)^\S*$

An absolute URI that is used to identify this questionnaire when it is referenced in a specification, model, design or an instance; also called its canonical identifier. This SHOULD be globally unique and SHOULD be a literal address at which at which an authoritative instance of this questionnaire is (or will be) published. This URL can be the target of a canonical reference. It SHALL remain the same when the questionnaire is stored on different servers.

Example:"https://example.org/resource"
_urlobject(Element)

Extensions for url

identifierArray of objects(Identifier)

A formal identifier that is used to identify this questionnaire when it is represented in other formats, or referenced in a specification, model, design or an instance.

versionstring(string)^[ \r\n\t\S]+$

The identifier that is used to identify this version of the questionnaire when it is referenced in a specification, model, design or instance. This is an arbitrary value managed by the questionnaire author and is not expected to be globally unique. For example, it might be a timestamp (e.g. yyyymmdd) if a managed version is not available. There is also no expectation that versions can be placed in a lexicographical sequence.

Example:"example-string"
_versionobject(Element)

Extensions for version

namestring(string)^[ \r\n\t\S]+$

A natural language name identifying the questionnaire. This name should be usable as an identifier for the module by machine processing applications such as code generation.

Example:"example-string"
_nameobject(Element)

Extensions for name

titlestring(string)^[ \r\n\t\S]+$

A short, descriptive, user-friendly title for the questionnaire.

Example:"example-string"
_titleobject(Element)

Extensions for title

derivedFromArray of strings

The URL of a Questionnaire that this Questionnaire is based on.

Example:
[ "http://example.org/Profile" ]
statusany

The status of this questionnaire. Enables tracking the life-cycle of the content.

Enum:"draft""active""retired""unknown"
Example:"draft"
_statusobject(Element)

Extensions for status

experimentalboolean(boolean)^true|false$

A Boolean value to indicate that this questionnaire is authored for testing purposes (or education/evaluation/marketing) and is not intended to be used for genuine usage.

Example:true
_experimentalobject(Element)

Extensions for experimental

subjectTypeArray of strings

The types of subjects that can be the subject of responses created for the questionnaire.

Example:
[ "sample-code" ]
_subjectTypeArray of objects(Element)

Extensions for subjectType

datestring, (date-time)(dateTime)^([0-9]([0-9]([0-9][1-9]|[1-9]0)|[1-9]00)|[1-...

The date (and optionally time) when the questionnaire was published. The date must change when the business version changes and it must change if the status code changes. In addition, it should change when the substantive content of the questionnaire changes.

Example:"2024-01-01T00:00:00Z"
_dateobject(Element)

Extensions for date

publisherstring(string)^[ \r\n\t\S]+$

The name of the organization or individual that published the questionnaire.

Example:"example-string"
_publisherobject(Element)

Extensions for publisher

contactArray of objects(ContactDetail)

Contact details to assist a user in finding and communicating with the publisher.

descriptionstring(markdown)^[ \r\n\t\S]+$

A free text natural language description of the questionnaire from a consumer's perspective.

Example:"Sample markdown text"
_descriptionobject(Element)

Extensions for description

useContextArray of objects(UsageContext)

The content was developed with a focus and intent of supporting the contexts that are listed. These contexts may be general categories (gender, age, ...) or may be references to specific programs (insurance plans, studies, ...) and may be used to assist with indexing and searching for appropriate questionnaire instances.

jurisdictionArray of objects(CodeableConcept)

A legal or geographic region in which the questionnaire is intended to be used.

purposestring(markdown)^[ \r\n\t\S]+$

Explanation of why this questionnaire is needed and why it has been designed as it has.

Example:"Sample markdown text"
_purposeobject(Element)

Extensions for purpose

copyrightstring(markdown)^[ \r\n\t\S]+$

A copyright statement relating to the questionnaire and/or its contents. Copyright statements are generally legal restrictions on the use and publishing of the questionnaire.

Example:"Sample markdown text"
approvalDatestring, (date)(date)^([0-9]([0-9]([0-9][1-9]|[1-9]0)|[1-9]00)|[1-...

The date on which the resource content was approved by the publisher. Approval happens once when the content is officially approved for usage.

Example:"2024-01-01"
_approvalDateobject(Element)

Extensions for approvalDate

lastReviewDatestring, (date)(date)^([0-9]([0-9]([0-9][1-9]|[1-9]0)|[1-9]00)|[1-...

The date on which the resource content was last reviewed. Review happens periodically after approval but does not change the original approval date.

Example:"2024-01-01"
_lastReviewDateobject(Element)

Extensions for lastReviewDate

effectivePeriodobject(Period)

The period during which the questionnaire content was or is planned to be in active use.

codeArray of objects(Coding)

An identifier for this question or group of questions in a particular terminology such as LOINC.

itemArray of objects(Questionnaire_Item)

A particular question, question grouping or display text that is part of the questionnaire.

Example:
[ { "linkId": "1", "code": [ … ], "type": "group", "item": [ … ] }, { "linkId": "2", "code": [ … ], "type": "group", "item": [ … ] } ]
Response
{ "resourceType": "Questionnaire", "id": "3141", "text": { "status": "generated", "div": "<div xmlns=\"http://www.w3.org/1999/xhtml\">\n <pre>\n 1.Comorbidity?\n 1.1 Cardial Comorbidity\n 1.1.1 Angina?\n 1.1.2 MI?\n 1.2 Vascular Comorbidity?\n ...\n Histopathology\n Abdominal\n pT category?\n ...\n </pre>\n </div>" }, "url": "http://hl7.org/fhir/Questionnaire/3141", "title": "Cancer Quality Forum Questionnaire 2012", "status": "draft", "subjectType": [ "Patient" ], "date": "2012-01", "item": [ { … }, { … } ] }